function param = estwarp_condens_CNNT(frame, param, tmpl, frameNum, backgroundThreshold, netId)
negNum = 16;
p = param.est;
ave_len = (p(3) + p(4)) / 2;

numscale = 4;
feas = forwardtest(tmpl, frame, numscale + negNum);
negSample = [];
%% Collect negsamples with high response on the CNN
for i = numscale + 1 : numscale + negNum
    if (sum(sum(feas(:, :, i))) > backgroundThreshold)
        negSample = [negSample, tmpl.basis(:, i)];
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% h = figure;
% for i = 1:4
%     outMask = imresize(feas(:,:, i), [100, 100]);
%     imshow(uint8(reshape(tmpl.basis(:,i), [100,100,3])));
%     print(h, '-djpeg', ['img/net_', num2str(netId), 'frame_', num2str(frameNum), 'posSample', num2str(i)]);
%     imshow(outMask, []);
%     print(h, '-djpeg', ['img/net_', num2str(netId), 'frame_', num2str(frameNum), 'posMask', num2str(i)]);
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

bestConf = -1e9;
bestCord = zeros(1,4);
%% search for all the scales and choose the best
for scale = 1 : numscale
    curfea = feas(:, :, scale);
    i = 1;
    clear x1_ y1_ x2_ y2_;
    for threshold = 0.1 : 0.1 : 0.7
        tmp = curfea > threshold;
        if sum(sum(tmp)) < 10
            break;
        end
        [x1_(i),y1_(i),x2_(i),y2_(i)] = findbox(tmp);
        i = i + 1;
    end
    if ~exist('x1_', 'var')
        continue;
    end
    curCord = mean([x1_', y1_', x2_', y2_'], 1);
    fea = feas(:, :, scale);
    x1 = curCord(1); x2 = curCord(3);
    y1 = curCord(2); y2 = curCord(4);

    param.lastUpdate = 1;
    

    curconf = mean(mean(fea(x1 : x2, y1 : y2)));

    % calculate the location in the original frame
    scale_ratio = scale * 0.5;
    scaleWidth = (p(3) + scale_ratio * ave_len ) / 50;
    scaleHeight = (p(4) + scale_ratio * ave_len ) / 50;
    new_center = [(x1+x2)/2, (y1+y2)/2];
    center_x = (1 + 50)/2;
    center_y = (1 + 50)/2;
    new_p = p;
    new_p(1) = (p(1) + (new_center(1) - center_x ) * scaleWidth);
    new_p(2) = (p(2) + (new_center(2) - center_y ) * scaleHeight);

    

    % search for a proper scale.
    h = p(3) + scale_ratio * ave_len;
    w = p(4) + scale_ratio * ave_len;
    oriResizedMap = imresize(fea, [w, h]);
%     [w, h] = size(oriResizedMap);
   
    totalScale = 0;
    totalRatio = 0;
    for th = 1 : 0.05 : 1.3
        resizedMap = max(oriResizedMap, 0) * 2 - th;
        resizedMap(resizedMap < -th + 0.1) = -2;
%         resizedMap = tanh(resizedMap * 2) * 2;
%         resizedMap(resizedMap < -0.95) = -2;
        iter_center(1) = new_center(1) * h / 50;
        iter_center(2) = new_center(2) * w / 50;
        forDecision = -1e9;
        curRes = -1e9;
        bestScale = 0;
        bestRatio = 0;
        sumMap = integral(double(resizedMap));
        for i = -0.02 : 0.001 : 0.02
            for j = 0.00 : 0.002 : 0.00
                newH = p(3) * (1 + i);
                newW = p(4) * (1 + i) * (1 + j);
                x1 = round(max(1, iter_center(2) - newW / 2));
                x2 = round(min(w, iter_center(2) + newW / 2));
                y1 = round(max(1, iter_center(1) - newH / 2));
                y2 = round(min(h, iter_center(1) + newH / 2));
%                 inConf = sum(sum(resizedMap(x1 : x2, y1 : y2)));
                x1 = x1 - 1;
                y1 = y1 - 1;
                inConf = get(sumMap, x2, y2) - get(sumMap,x1, y2) - ...
                    get(sumMap, x2, y1) + get(sumMap, x1, y1);
                fmeasure = inConf * (newH * newW) / p(3) / p(4);

                if fmeasure > curRes 
                    curRes = fmeasure;
                    bestScale = i;
                    bestRatio = j;
                    forDecision = inConf / newH / newW;
                end
            end
        end
        if forDecision < 0
            bestScale = 0;
            bestRatio = 0;
        end
        totalScale = totalScale + bestScale;
        totalRatio = totalRatio + bestRatio;
    end
    totalScale = totalScale / 7;
    totalRatio = totalRatio / 7;
    new_p(3) = ( p(3) * (1 + totalScale) );
    new_p(4) = ( p(4) * (1 + totalScale) * (1 + totalRatio));
  
%     if(new_center(1) + new_p(3) / scaleWidth / 2 >= 50 || new_center(1) - new_p(3) / scaleWidth / 2 <= 1 ||...
%             new_center(2) + new_p(4) / scaleHeight / 2 >= 50 || new_center(2) - new_p(4) / scaleHeight / 2 <= 1  )
%         continue;
%     else
        bestP = new_p;
        param.conf = curconf;
        param.negSample = negSample;
        param.est = bestP;
        return;
%     end
end

param.negSample = [];
param.lastUpdate = 0;
param.conf = 0;
end

function res = get(map, x, y)
    if x == 0 || y == 0
        res = 0;
    else 
        res = map(x, y);
    end
end
   

